Bug 168750 - xorg-x11-6.8.2-1.FC3.45 update causes regression in video hardware support
xorg-x11-6.8.2-1.FC3.45 update causes regression in video hardware support
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: xorg-x11 (Show other bugs)
3
All Linux
medium Severity medium
: ---
: ---
Assigned To: X/OpenGL Maintenance List
David Lawrence
:
: 168622 168623 168631 168714 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2005-09-19 21:55 EDT by Mike A. Harris
Modified: 2007-11-30 17:11 EST (History)
10 users (show)

See Also:
Fixed In Version: xorg-x11-6.8.2-1.FC3.45.1
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-09-20 22:41:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
My Xorg.0.log file (35.11 KB, text/plain)
2005-09-20 14:56 EDT, Tomas Linden
no flags Details

  None (edit)
Description Mike A. Harris 2005-09-19 21:55:15 EDT
Description of problem:

The xorg-x11-6.8.2-1.FC3.45 update recently released for Fedora Core 3,
contained a security fix, as well as a number of bug fixes and hardware
support updates.

One of the bugs this update addressed, was a PCI config space contention
issue which has been present in the X server forever, but which has only
recently become a major issue with current generation computer systems.

Previously, the X server would read/write to the PCI config registers
directly on its own, instead of using safe arbitrated access mechanisms
provided by the Linux kernel.  If some other kernel driver or userland
code running as root were to access the PCI config space registers at
the exact same time the X server starts up, the result would be a system
that randomly hung, or any number of other spurious and transient
problems.

The only way to safely solve the PCI config space contention issue
permanently, was to change the X server to access PCI config space via
the kernel, so that the kernel is fully in control of access, and can
thus ensure no 2 things access the hardware simultaneously, thus preventing
contention from causing system lockups and other odd spurious crashes or
other behaviour.

The upstream X sources have had the ability to use the OS PCI config space
access mechanisms for quite a long time now, however it was never enabled 
by default upstream before for x86 class hardware.  The initial solution
was to simply enable this code as the default for all Linux platforms, as
it is the only "safe" way to access PCI config space without contention.

The xorg-x11-6.8.2-use-linux-native-pciscan-by-default.patch was implemented
to solve the PCI config space contention problem, by changing the defaults
in the X source many months ago.  This change was also made upstream by
X.Org to CVS.  After a few weeks of testing in rawhide, etc. it was
discovered that there were some problems in the X code to use native OS
access mechanisms, and those issues were addressed upstream and also in
Fedora Core as well.

This is more or less what shipped in Fedora Core 4's first xorg update,
and it seemed to work fairly well, however we did receive a number of bug
reports from Matrox, Intel and some other users which over time we were
able to pinpoint down to the pciconfig patch.  Deeper investigation
indicated that the X server code for using native OS pci config access
needed some additional changes to the X server due to some bad assumptions
in the X server's PCI code.  The patch was updated and the known issues
were resolved.

Later, it was determined that some Matrox hardware still had problems with
the pciconfig patch.  An investigation was done into the matter, which
showed that the Matrox video BIOS was accessing hardware registers outside
of PCI config space.  The X server PCI handling code did not anticipate
this type of usage scenario, and an optimization present in the code
caused the Matrox BIOS to trigger a false assumption in the code.  This
issue was fixed, however it was unclear just how many video BIOSes out
there might be affected by the problem, or by other problems also yet
undiscovered.

At this point, the pciconfig patch was updated to fix all known problems
that could be linked to it, and it was tested internally on a variety of
video hardware and systems.  No further regressions were discovered, and
a number of users had been affected by the previous regressions, so the
updated pciconfig patch was considered a critical bug fix and was added
to the queue for the next update.

After releasing the latest update (xorg-x11-6.8.2-1.FC3.45) along with
the other bugfixes, some users have reported a regression in video hardware
support, in particular on Intel i8xx/i9xx systems, but also on some other
video hardware as well.

We have immediately investigated these issues internally, and were able
to reproduce the problem on a system and diagnose the cause of the issue
to another small bug in the X server's PCI config space handling code.

The pci-config patch has been updated with this fix, and is currently being
re-tested on various video hardware internally.  Once we've resolved any
regressions that are detected during our internal testing, we will provide
new rpms for users to test and provide feedback.

Once we've received enough feedback from testers that the testing rpms
resolve the regressions they've experienced, we will release a new
official update for Fedora Core 3 and 4.
Comment 1 Mike A. Harris 2005-09-19 22:21:11 EDT
*** Bug 168622 has been marked as a duplicate of this bug. ***
Comment 2 Mike A. Harris 2005-09-19 22:25:46 EDT
*** Bug 168623 has been marked as a duplicate of this bug. ***
Comment 3 Mike A. Harris 2005-09-19 22:26:27 EDT
*** Bug 168631 has been marked as a duplicate of this bug. ***
Comment 4 Mike A. Harris 2005-09-19 22:39:07 EDT
*** Bug 168714 has been marked as a duplicate of this bug. ***
Comment 5 Mike A. Harris 2005-09-19 22:59:58 EDT
For everyone who has experienced this problem with the latest Fedora Core 3
update, please test these beta rpms for FC3, and report status back here:

    http://people.redhat.com/krh/xorg-x11/fc3

Setting status to "NEEDINFO"
Comment 6 David Kinzer 2005-09-20 01:50:44 EDT
These rpms fixed my very unhappy system.  I got to learn a lot this evening
about manually installing rpms.  I believe my system (hp-m7060n) contains an ATI
Radeon x300 SE video card.
Comment 7 Tiia 2005-09-20 02:21:15 EDT
(In reply to comment #5)
> For everyone who has experienced this problem with the latest Fedora Core 3
> update, please test these beta rpms for FC3, and report status back here:
> 
>     http://people.redhat.com/krh/xorg-x11/fc3
> 
> Setting status to "NEEDINFO"

It works also bug 168714. My laptop is alive again. Thank You!
Comment 8 Mike A. Harris 2005-09-20 03:09:47 EDT
RPMS for x86_64, ppc, etc. also now available at:

xorg-x11-6.8.2-1.FC3.45.1 is now available for download via ftp at the following
URL:  ftp://people.redhat.com/mharris/testing/fc3
xorg-x11-6.8.2-37.FC4.49.1 is now available for download via ftp at the
following URL:  ftp://people.redhat.com/mharris/testing/fc4
Comment 9 Tomas Linden 2005-09-20 13:46:23 EDT
I´m running Fedora Core 3 with automatic updates using yum on a 400 MHz K6-2 
machine with 192 MB RAM and a Radeon 9200 SE PCI card. The upgrade to 
6.8.2-1.FC3.45 hangs X on my machine. The machine can be accessed remotly using 
ssh, though. I upgraded to xorg-x11-6.8.2-1.FC3.45.1, but unfortunately X still 
hangs on my machine.

tlinden@fenix ~> uname -a
Linux fenix 2.6.12-1.1376_FC3 #1 Fri Aug 26 23:27:19 EDT 2005 i586 i586 i386 
GNU/Linux

00:14.0 VGA compatible controller: ATI Technologies Inc RV280 [Radeon 9200 SE] 
(rev 01) (prog-if 00 [VGA])
        Subsystem: PC Partner Limited: Unknown device 7c25
        Flags: bus master, medium devsel, latency 66, IRQ 9
        Memory at f0000000 (32-bit, prefetchable) [size=128M]
        I/O ports at f800 [size=256]
        Memory at fedf0000 (32-bit, non-prefetchable) [size=64K]
        Capabilities: [50] Power Management version 2

00:14.1 Display controller: ATI Technologies Inc RV280 [Radeon 9200 SE] 
(Secondary) (rev 01)
        Subsystem: PC Partner Limited: Unknown device 7c24
        Flags: bus master, medium devsel, latency 66
        Memory at e8000000 (32-bit, prefetchable) [disabled] [size=128M]
        Memory at fede0000 (32-bit, non-prefetchable) [disabled] [size=64K]
        Capabilities: [50] Power Management version 2

tlinden@fenix ~> rpm -qa | grep xorg
xorg-x11-font-utils-6.8.2-1.FC3.45.1
xorg-x11-xdm-6.8.2-1.FC3.45.1
fonts-xorg-base-6.8.2-0.FC3.1
xorg-x11-doc-6.8.2-1.FC3.45.1
xorg-x11-6.8.2-1.FC3.45.1
xorg-x11-sdk-6.8.2-1.FC3.45.1
xorg-x11-Mesa-libGL-6.8.2-1.FC3.45.1
xorg-x11-xfs-6.8.2-1.FC3.45.1
xorg-x11-tools-6.8.2-1.FC3.45.1
xorg-x11-Xnest-6.8.2-1.FC3.45.1
fonts-xorg-75dpi-6.8.2-0.FC3.1
xorg-x11-Xvfb-6.8.2-1.FC3.45.1
xorg-x11-libs-6.8.2-1.FC3.45.1
xorg-x11-xauth-6.8.2-1.FC3.45.1
xorg-x11-deprecated-libs-6.8.2-1.FC3.45.1
xorg-x11-Xdmx-6.8.2-1.FC3.45.1
fonts-xorg-100dpi-6.8.2-0.FC3.1
xorg-x11-deprecated-libs-devel-6.8.2-1.FC3.45.1
xorg-x11-devel-6.8.2-1.FC3.45.1
xorg-x11-Mesa-libGLU-6.8.2-1.FC3.45.1
xorg-x11-twm-6.8.2-1.FC3.45.1tlinden@fenix ~> rpm -qa | grep xorg
xorg-x11-font-utils-6.8.2-1.FC3.45.1
xorg-x11-xdm-6.8.2-1.FC3.45.1
fonts-xorg-base-6.8.2-0.FC3.1
xorg-x11-doc-6.8.2-1.FC3.45.1
xorg-x11-6.8.2-1.FC3.45.1
xorg-x11-sdk-6.8.2-1.FC3.45.1
xorg-x11-Mesa-libGL-6.8.2-1.FC3.45.1
xorg-x11-xfs-6.8.2-1.FC3.45.1
xorg-x11-tools-6.8.2-1.FC3.45.1
xorg-x11-Xnest-6.8.2-1.FC3.45.1
fonts-xorg-75dpi-6.8.2-0.FC3.1
xorg-x11-Xvfb-6.8.2-1.FC3.45.1
xorg-x11-libs-6.8.2-1.FC3.45.1
xorg-x11-xauth-6.8.2-1.FC3.45.1
xorg-x11-deprecated-libs-6.8.2-1.FC3.45.1
xorg-x11-Xdmx-6.8.2-1.FC3.45.1
fonts-xorg-100dpi-6.8.2-0.FC3.1
xorg-x11-deprecated-libs-devel-6.8.2-1.FC3.45.1
xorg-x11-devel-6.8.2-1.FC3.45.1
xorg-x11-Mesa-libGLU-6.8.2-1.FC3.45.1
xorg-x11-twm-6.8.2-1.FC3.45.1

top - 20:39:46 up 38 min,  1 user,  load average: 1.18, 1.26, 1.14
Tasks:  50 total,   2 running,  48 sleeping,   0 stopped,   0 zombie
Cpu(s):  0.3% us, 99.6% sy,  0.0% ni,  0.0% id,  0.0% wa,  0.1% hi,  0.0% si
Mem:    190984k total,   180016k used,    10968k free,    10664k buffers
Swap:   385520k total,        0k used,   385520k free,   126740k cached

  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND           
 3335 root      25   0  148m 7916 1836 R 99.3  4.1  33:41.80 X
Comment 10 Tomas Linden 2005-09-20 14:56:28 EDT
Created attachment 119041 [details]
My Xorg.0.log file
Comment 11 jostle 2005-09-20 20:22:57 EDT
(In reply to comment #5)
> For everyone who has experienced this problem with the latest Fedora Core 3
> update, please test these beta rpms for FC3, and report status back here:
> 
>     http://people.redhat.com/krh/xorg-x11/fc3
> 
> Setting status to "NEEDINFO"

Thanks, that seems to have fixed the problem on my system.
Some relevant system info ...

> uname -a
Linux dhcp-12 2.6.12-1.1376_FC3smp #1 SMP Fri Aug 26 23:50:33 EDT 2005 i686 i686
i386 GNU/Linux
> lspci
00:00.0 Host bridge: Intel Corporation 915G/P/GV Processor to I/O Controller
(rev 04)
00:02.0 VGA compatible controller: Intel Corporation 82915G/GV/910GL Express
Chipset Family Graphics Controller (rev 04)
00:02.1 Display controller: Intel Corporation 82915G Express Chipset Family
Graphics Controller (rev 04)
...
Comment 12 Bill Mills-Curran 2005-09-20 22:19:38 EDT
(In reply to comment #3)

My problem is fixed now, too.  I did not test with the beta version -- I was too
slow to get to it.  I did update with up2date.  Everything's fine.  Great
response.  Thanks.
Comment 13 Yasuhiko Okada 2005-09-20 22:47:29 EDT

Hello. I have tested with my computer and found no problem
by now.

OS : Fedore core3
MB : MSI 865GNeo2-PLS (Intel 865G)

--------------------------------------------------
I just updated with the following files from
   http://people.redhat.com/krh/xorg-x11/fc3

xorg-x11-6.8.2-1.FC3.45.i386.rpm
xorg-x11-Xdmx-6.8.2-1.FC3.45.i386.rpm
xorg-x11-Xnest-6.8.2-1.FC3.45.i386.rpm
xorg-x11-Xvfb-6.8.2-1.FC3.45.i386.rpm
xorg-x11-libs-6.8.2-1.FC3.45.i386.rpm
xorg-x11-xfs-6.8.2-1.FC3.45.i386.rpm
--------------------------------------------------


>uname -a

Linux XXX 2.6.12-1.1376_FC3smp #1 SMP Fri Aug 26 23:50:33 EDT 2005 i686 i686
i386 GNU/Linux

>lspci 
00:00.0 Host bridge: Intel Corporation 82865G/PE/P DRAM Controller/Host-Hub
Interface (rev 02)
00:02.0 VGA compatible controller: Intel Corporation 82865G Integrated Graphics
Controller (rev 02)
Comment 14 nyinge 2005-09-21 03:02:37 EDT
GUI works perfectly on my system now.  Thanks a bunch.

Detailed info:

>uname -r
2.6.12-1.1447_FC4

>rpm -q xorg-x11
xorg-x11-6.8.2-37.FC4.49.1

>lspci
00:00.0 Host bridge: Intel Corporation 82830 830 Chipset Host Bridge (rev 04)
00:02.0 VGA compatible controller: Intel Corporation 82830 CGC [Chipset Graphics
Controller] (rev 04)
00:02.1 Display controller: Intel Corporation 82830 CGC [Chipset Graphics
Controller]
Comment 15 Olli Herranen 2005-09-22 02:53:03 EDT
ftp://people.redhat.com/mharris/testing/fc4 is empty. Should the files still be
there, I'm having this problem with 25 machines... 
Comment 16 Olli Herranen 2005-09-22 03:17:05 EDT
Ok, http://people.redhat.com/krh/xorg-x11/fc4/ works and fixes the problem, but
devel-packages have to be left alone. Thanks a lot!

-Olli

Note You need to log in before you can comment on or make changes to this bug.